#!/usr/bin/perl
#
# $Id: cleanup.pl,v 1.5 1998/05/14 11:54:05 wralph Exp $
#
#  Script to clean up the directory on the SENSOR to prevent loss of data 
#  due to a disk partition filling up. 
#  This script will be run by cron nightly.
#  
#  Written by Bill Ralph 2/24/98
#  Re-written by Bill Ralph in Perl 3/12/98
#
# Set up some variables.
#
use Getopt::Long;
use POSIX qw(strftime);
#
$CID_PATH = "/usr/local/logger";
$ENV{PATH} = "/bin:/usr/bin:/usr/sbin:/usr/local/bin:/usr/local/sbin:$CID_PATH";

#
sub usage {
        print "Usage: cleanup.pl [-debug] -d CLEAN_DATE -l Site.\n";
        exit 2;
}
#
#	Parse the parameters.
#
&GetOptions("debug", \$debug, "d:s", \$clean_date, "l=s", \$Site);

#
# Once the Site is identified from the command line,
# load the needed external Parameters.
#
unshift(@INC, "$CID_PATH/sites");
require "${Site}.ph";

#
##
#
#  Rid ourselves of standard output and error to prevent tons of mail messages
#  from cron.
#
@lvls = split(/\//,$0);				# Split path
($call, $suf) = split(/\./, $lvls[$#lvls]);	# Split call.suffix
$LOG_FILE = $debug ? "/tmp/$call.log" : "/dev/null";
open(STDOUT, ">>$LOG_FILE");
select STDOUT; $| = 1;
open(STDERR, ">&STDOUT");
select STDERR; $| = 1;              # make unbuffered

   print "Command line: d = $clean_date \n";
   print "Command line: l = $Site \n";

#
# Writer a marker to the log file.
#
$marker=strftime("%c", localtime(time));
chomp $marker;
print STDOUT $marker;
foreach $param ($0, @ARGV) {
   printf " %s", $param;
}
print STDOUT "\n";
#
# If the $clean_date is specified in the call, use it, otherwise
# use the default specified in the site-specific .ph file.
#
$clean_date = $CLEAN_DATE unless ($clean_date);
print STDOUT "clean_date = $clean_date\n";

#
#
# Remove the files matching our clean_date
#
$file_pat="tcp.$clean_date??.gz";
$cmd="df $SENSOR_DIR;rm $SENSOR_DIR/$file_pat;df $SENSOR_DIR";
$cmd='"' . $cmd . '"';

   print STDOUT "Removing $SENSOR_DIR/$file_pat from $SENSOR.\n";
   print STDOUT ("ssh -l root $SENSOR $cmd\n");

   system ("ssh -l root $SENSOR $cmd");

#
