#!/usr/bin/perl
#
#file: frames.pl

use CGI qw/:standard/;
use CGI::Carp qw(fatalsToBrowser);
use POSIX qw(strftime);
use Time::Local;
#
$CID_DIR = "/usr/local/logger";
$GENERIC_FILTERS = "$CID_DIR/filters/generic";
%month_no = (
   "Jan" => 0, "Feb" => 1, "Mar" => 2, "Apr" => 3, "May" => 4, "Jun" => 5,
   "Jul" => 6, "Aug" => 7, "Sep" => 8, "Oct" => 9, "Nov" => 10, "Dec" => 11);
%scan_types = (
               '$GENERIC_FILTERS/reset' => 'Reset', 
               '$GENERIC_FILTERS/icmp' => 'ICMP');
$today_mday = strftime("%d", localtime(time));
$today_month = strftime("%h", localtime(time));
$today_year = strftime("%Y", localtime(time));
print header,
start_html(-title=>'SHADOW Daily Scan Search',
           -author=>'wralph@nswc.navy.mil',
           -background=>'/images/red_rock.gif');
if (!param) {
   print h1({-align=>CENTER}, "Search for a scan in a day's sensor logs."),
   start_form(-target=>'_self'),
   "Site: ", 
   radio_group(-name=>'site',
               -values=>['NSWC','NAVSEA','NAVSSES','JNTF', 'BMDO1'],
               -defaults=>['NSWC']),
   p(),
   "Host Name Lookup: ", 
   radio_group(-name=>'nslookup',
               -values=>['Yes','No'],
               -default=>'Yes'),
   p(),
   "Year: ",
   popup_menu(-name=>'year',
              -values=>['1997','1998','1999','2000','2001'],
              -default=>$today_year),
   "Month: ",
   popup_menu(-name=>'month',
              -values=>['Jan','Feb','Mar','Apr','May','Jun','Jul','Aug','Sep',
                        'Oct','Nov','Dec'],
              -default=>$today_month),
   "Day of Month: ",
   popup_menu(-name=>'day',
              -values=>['1','2','3','4','5','6','7','8','9','10','11','12','13',
                        '14','15','16','17','18','19','20','21','22','23','24',
                        '25','26','27','28','29','30','31'],
              -default=>$today_mday),
   p(),
   "Scan type: ",
    popup_menu(-name=>'scan_type',
              -values=>['$GENERIC_FILTERS/reset','$GENERIC_FILTERS/icmp'],
              -labels=>\%scan_types,
              -default=>'$GENERIC_FILTERS/reset'),
   p(),
   submit,
   end_form;
} else {
   select STDOUT; $| = 1;              # make unbuffered
   $date = strftime("%y%m%d", 0, 0, 0, param('day'), $month_no{param('month')}, 
                    param('year'), 0, 0, 0);
   $site = param('site');
   $nslookup = (param('nslookup') eq 'Yes')?"":"-n";
   $filter = param('scan_type');
   $cmd="$CID_DIR/look4scans.pl $nslookup -d $date -l $site -f $filter";
   $perl_cmd = "$CID_DIR/look4scans.pl";
   $perl_cmd_params = "$lookup -d $date -l $site -f '$filter'";
   print h1("Your answers: ");
   print p(" Site: $site, - Date:  $date - Filter: $filter");
   print p("$perl_cmd $perl_cmd_params");
   print STDOUT "\n<PRE>\n";
   open(SEARCH, "$cmd|") || die "Can't open search script: $!\n" ;
   while (<SEARCH>) {
      print STDOUT $_;
   }
#   system('$perl_cmd', $perl_cmd_params);
   print STDOUT "\n</PRE>\n";
}
print end_html;
