#!/usr/bin/perl
#
# shutdown-wrapper for the tcpdump used in the CID tool.
#
# Author: Olav Kolbu <olav.kolbu@usit.uio.no>
# Modifier: Bill Ralph <wralph@nswc.navy.mil>
#
# This code is hereby released into the public domain. It is released
# "as-is". All warranties disclaimed, implied or otherwise.
# 

# These are the external variables we need
unshift(@INC, "/usr/local/logger/sensor");
require "variables.ph";

if ( -f $LOGPID )
{
#  @pids = split(`cat $LOGPID`);
#
# When the master script is starting, there exists some time when more that
# one process is running that contains the "tcpdump" or $LOGPROG strings.
# The logic here assumes that the LOGPID file may have more than one pid
# in it. We kill them all!
#
  open(PIDFILE, "<${LOGPID}");
  @pids = split(/\s+/,<PIDFILE>);
  close(PIDFILE);
  foreach $pid (@pids) {

    if ( ! $pid )
    {
      print "$0: Pid file '$LOGPID' bad or empty, aborting\n";
      exit 1;
    }
    elsif ( kill (0, int($pid)) )
    {
      kill (9, int($pid));    
      sleep(2); # Give the program some time to finish
      if ( kill (0, int($pid)) )
      {
        print "$0: Unable to kill $LOGPROG, aborting\n";
        exit 1;
      }
    }
    else
    {
      print "$0: PID: $pid was not running\n";
      next;
    }
  }
  unlink $LOGPID;
}
else
{
  # Here we could have tried to locate the pid using 'ps' but
  # we might zap a vital tcpdump run by some BOFH so we abstain.
  print "$0: NO pid file '$LOGPID', aborting\n";
  exit 1; 
}

exit 0;
